package com.jasamedika.medifirst2000.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.CssdMonitoringSteamService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.CssdMonitoringSteamVO;

@RestController
@RequestMapping("/cssd-monitoring-steam")
public class CssdMonitoringSteamController extends LocaleController {
	
	@Autowired
	private CssdMonitoringSteamService cssdMonitoringSteamService;
	
	private static final Logger LOGGER = LoggerFactory.getLogger(CssdMonitoringSteamController.class);

	@RequestMapping(value = "/save-monitoring-steam/", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveMoioringEo(@Valid @RequestBody CssdMonitoringSteamVO vo,HttpServletRequest request,HttpServletResponse response) {
		
		try {
			Map<String, Object> result = cssdMonitoringSteamService.saveMonitoringSteam(vo);
			if (null != result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when save MonitoringSteam", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when save  save MonitoringSteam", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}
	
	// Menampilkan Kartu Pengendali Berdasarkan Norec (array)
		@RequestMapping(value = "/detail-monitoring-steam", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
		public Map<String, Object> detailMonitoringSteam(@RequestParam(value = "strukPelayananId", required = true) String strukPelayananId) {
			Map<String, Object> result = cssdMonitoringSteamService.detailMonitoringSteam(strukPelayananId);

			return result;
		}
	
	

}
